//	--------------------------------------------------------------------------
//
//	PALETTES.HPP
//
//	--------------------------------------------------------------------------

#ifndef		__palettes_hpp
#define		__palettes_hpp

#include	"graphics.hpp"
#include	"resource.hpp"

#define		STANDARD_PALETTE_SIZE		769L

// Get size of a palette in a .PAL file
long	PAL_SizeOfPalette (DirString* filename);

// Load/Save a palette from/to a .PAL file
int		PAL_LoadPalette (DirString* filename, grPalette* dest, bool enable_palette = false);
int		PAL_SavePalette (DirString* filename, grPalette* srce, long size = STANDARD_PALETTE_SIZE);

//	---------------------------------------------------------------------------

class PaletteResourceFile : public ResourceFile
	{
	public:
		PaletteResourceFile(DirString* pathname,uint options,long num_resources = 256);
		PaletteResourceFile(const char* pathname,uint options,long num_resources = 256);
		~PaletteResourceFile();

		int				ReadResource(long resource_num,grPalette* buffer);
		int				AddResource(DirString* srce);

		virtual char**	LoadAllResources();
		virtual void	FreeAllResources(char** datalist);
	};

#endif
