//
//	stddefns.h
//
//	contains any definitions possibly required by all applications.
//
//	AUTHOR:			Darren J. Dwyer
//

#ifndef __stddefns_h
#define __stddefns_h

#include "stdlib.h"
#include "math.h"

// standard defns

#ifndef true
#define	true	1
#endif
#ifndef false
#define false	0
#endif


#ifndef schar
#define	schar	signed char
#endif
#ifndef uchar
#define uchar 	unsigned char
#endif
#ifndef byte
#define byte	unsigned char
#endif
#ifndef BYTE
#define BYTE	unsigned char
#endif
#ifndef sshort
#define	sshort	signed short
#endif
#ifndef	ushort
#define ushort	unsigned short
#endif
#ifndef	WORD
#define WORD	unsigned short
#endif
#ifndef word
#define word 	unsigned short
#endif
#ifndef sint
#define sint	signed int
#endif
#ifndef uint
#define uint 	unsigned int
#endif
#ifndef slong
#define	slong	signed long
#endif
#ifndef ulong
#define ulong 	unsigned long
#endif
#ifndef dword
#define	dword	unsigned long
#endif
#ifndef DWORD
#define	DWORD	unsigned long
#endif
#ifndef bool
#define bool 	char
#endif

// standard macros

//  return a random number in range of 0-N
#define random(N)		(rand() % (N))


//	return the difference between A and B
#define diff(A,B)		abs((A)-(B))

// define SYSTEM commands used in cmdevent mechanism here
// SYSTEM commands are in range 0x0000 to 0x0FFF
// user-defined commands can be in range 0x1000 to 0xF000

#define cmdNothing		100	// a null event
#define cmdExitProgram 	101	// to tell the main program to exit
#define cmdQuit			102	// to tell the main program to quit
#define cmdAnimate		103	// to tell all event handlers to animate
#define cmdRefresh		104	// to tell all event handlers to refresh
#define cmdOK			200	// standard positive response
#define cmdCANCEL		201 // standard negative response

#endif

